Attribute VB_Name = "mMap"
Option Explicit

'Types
    Public Type tMap
        w As Long 'W stands for width
        h As Long 'H stands for height
        
        Data() As Long
    End Type

'Variables
    Public Map As tMap
    
Public Sub CreateMap(iW As Long, iH As Long)
    With Map
        'Get size
        .w = iW
        .h = iH
        
        'Create map
        ReDim .Data(.w * .h)
    End With
End Sub

Public Sub Reset()
    'Reset map
    Map.w = 0
    Map.h = 0
    Erase Map.Data
End Sub

Public Sub Draw()
    Dim X As Long
    Dim Y As Long
    
    Dim Index As Long
    Dim TileIndex As Long
    
    With Map
        'Calculate map index from the camera positon
        Index = (Camera.Y * .w) + Camera.X
        
        'Draw the map
        For Y = 0 To Camera.TilesY - 1
            For X = 0 To Camera.TilesX - 1
                'Get tile index
                TileIndex = .Data(Index)
                
                'Draw tile
                BitBlt Camera.FrontDC, _
                    X * TileSize, Y * TileSize, _
                    TileSize, TileSize, _
                    Tile(TileIndex).DC, _
                    0, 0, _
                    vbSrcCopy
                
                'Next tile
                Index = Index + 1
            Next
            
            'Get next line start
            Index = Index + .w - Camera.TilesX
        Next
    End With
End Sub
Public Sub SetTile(iX As Long, iY As Long, Index As Long)
    'Set tile at the specified 0-based position
    Map.Data(iY * Map.w + iX) = Index
End Sub

